package clmFlexCode;

import com.ibm.rational.test.lt.kernel.services.ITestExecutionServices;

/**
 * @author Skye Bischoff
 */
public class CCMProjectIdExtraction implements
		com.ibm.rational.test.lt.kernel.custom.ICustomCode2 {

	/**
	 * Instances of this will be created using the no-arg constructor.
	 */
	public CCMProjectIdExtraction() {
	}

	/**
	 * For javadoc of ICustomCode2 and ITestExecutionServices interfaces, select 'Help Contents' in the
	 * Help menu and select 'Extending Rational Performance Tester functionality' -> 'Extending test execution with custom code'
	 */
	public String exec(ITestExecutionServices tes, String[] args) {
		// Initialize variables
		String result = args[1];
		String delims = null;
		String[] singleProjectListing = null;
		
		// Try catch block with if to capture any null pointers to avoid RPT runtime exceptions when this code is given garbage variables
        try {
        	if (args.length==3){
        		// Modify targetProjectName to match listing format
        		String targetProjectName = args[0];
        		targetProjectName = targetProjectName.replaceAll("%20", "+");
            	
        		// Current CCM Project ID
        		String currentCcmProjectId = args[1];
        		
        		// Project ID list which will come in one of two different formats
        		String projectIdList = args[2];
        		    		
        		if(currentCcmProjectId!=null&&currentCcmProjectId.length()==22){
        			// If the current project ID exists (22 digits) we want to continue to use its current value
        			result = currentCcmProjectId;
        		}else if(projectIdList==null){
        			result = "PROJECTIDLIST_NULL";
        		}else if(projectIdList.contains("</dc:title>")){
        			// If the projectIdList contains xml project flag then parse this way
        			delims = "[/]+";
        			singleProjectListing = projectIdList.split(delims);
        			result = singleProjectListing[singleProjectListing.length-1];
        			result = result.substring(1,result.length());
        		}else{
        			// If the projectiDList contains projectAreas then parse the ID out as follows
        			delims = "[\"]+";
            		singleProjectListing = projectIdList.split(delims);
            		
            		for(int i = 0; i < singleProjectListing.length-2; i++){
            		    if(singleProjectListing[i].equals("itemId")){
            		    	// Set projectId to next found ID, then we break in next if loop when we've found the correct project name 
            		    	result = singleProjectListing[i+2];
            		    	result = result.substring(1);
            		    }// end if
            			if(singleProjectListing[i].equals("name")&&singleProjectListing[i+2].equals(targetProjectName)){
            		    	break;  // Once a result is found break out of the loop to avoid any accidental conclusions
            		    }// end if 
            		}// end for loop 
        		}// end if else
        	}//end if
        }catch(Throwable t){
            // Log the exception and continue
        }// end try catch
        
        return result;

	}

}
